
//ver 3.7用
TYRANO.kag.ftag.master_tag.spine_new = {
		
	kag: TYRANO.kag,
	vital : ["name","storage","motion"],
    pm: {
		
    	name:"",
    	storage:"",
    	atlas:"",
    	skin:"default",
    	
    	motion:"",
    	
    	client_id:"",
    	
    	p_alpha:"true",
    	
    	next:"true",
    	
    },
    
	start: function(_pm) {
  		
  		var that = this;
  		
  		(function(pm){
			
			assetManager.loadText(plugin_path+"assets/"+pm.storage+"",function(){
	  			
	  			var atlas = pm.atlas;
		  			
	  			if(pm.atlas==""){
	  				atlas = $.replaceAll(pm.storage,".json",".atlas");
  				}
  				
		  		assetManager.loadTextureAtlas(plugin_path+"assets/"+atlas+"",function(){
					
					let timer_id = setInterval(function(){
							
						if(assetManager.isLoadingComplete()==false) return;
						
						clearInterval(timer_id);
						
					    let p_alpha = false;
					    
					    if(pm.p_alpha=="true"){
							p_alpha = true;
						}
						
						let storage_name = $.replaceAll(pm.storage,".json","");
						
					    var skeleton = _spine_loadSkeleton(storage_name, pm.motion, p_alpha, pm.skin);
					    
						let model_name = pm.name;
						
					    map_spine_player["models"][model_name] = {
						    "skeleton":skeleton,
						    "name":model_name,
						    "storage":pm.storage,
						    "atlas":pm.atlas,
						    "x":0,
						    "y":0,
						    "scale":0,
						    "visible":false,
						    "current_motion":pm.motion,
						    "skin":pm.skin,
					    };
					    
						//モデルをステータスに登録
						TYRANO.kag.stat.spine_models[model_name] = $.extend({},map_spine_player["models"][model_name]);
						delete TYRANO.kag.stat.spine_models[model_name]["skeleton"];
						
						if(pm.next=="true"){
							TYRANO.kag.ftag.nextOrder();
						}
						
						lastFrameTime = Date.now() / 1000;
						
						_start_requestframe();
				    
				    
				    }, 10);
					
			  	});
	    
	  		});
			
			
			
		})(_pm);
  		
		
	},

};


function _spine_loadSkeleton (name, initialAnimation, premultipliedAlpha, skin) {
	
	var assetManager = window.assetManager;

	if (skin === undefined) skin = "default";
	
	atlas = assetManager.get(plugin_path + "assets/" + name.replace("-ess", "").replace("-pro", "") + ".atlas");

	atlasLoader = new spine.AtlasAttachmentLoader(atlas);
	
	var skeletonJson = new spine.SkeletonJson(atlasLoader);
	
	var skeletonData = skeletonJson.readSkeletonData(assetManager.get(plugin_path + "assets/" + name + ".json"));
	
	var skeleton = new spine.Skeleton(skeletonData);
	
	skeleton.setSkinByName(skin);
	
	var bounds = _spine_calculateBounds(skeleton);

	animationStateData = new spine.AnimationStateData(skeleton.data);
	var animationState = new spine.AnimationState(animationStateData);
	
	animationStateData.defaultMix = 0.5;
	animationState.setAnimation(0, initialAnimation, true);
	
	animationState.addListener({
		
		start: function(track) {
			TYRANO.kag.log("Animation on track " + track.trackIndex + " started");
		},
		interrupt: function(track) {
			TYRANO.kag.log("Animation on track " + track.trackIndex + " interrupted");
		},
		end: function(track) {
			TYRANO.kag.log("Animation on track " + track.trackIndex + " ended");
		},
		disposed: function(track) {
			TYRANO.kag.log("Animation on track " + track.trackIndex + " disposed");
		},
		complete: function(track) {
			TYRANO.kag.log("Animation on track " + track.trackIndex + " completed");
		},
		event: function(track, event) {
			
			TYRANO.kag.log("Event on track " + track.trackIndex + ": " + JSON.stringify(event));
			let data = event.data;
			let obj = {};
			if(data.name=="tyranoevent"){
				
				let array1 = event.stringValue.split(",");
				for(let key in array1){
					let tmp = array1[key].split(":");
					obj[tmp[0]]= $.replaceAll(tmp[1],'"','');
				}
				
				obj.stop="true";
				obj.next="false";
				
				TYRANO.kag.ftag.startTag(obj.tag,obj);
				
			}
			
		}
		
		
		
	})

	return { skeleton: skeleton, state: animationState, bounds: bounds, premultipliedAlpha: premultipliedAlpha };
	
}

function _spine_calculateBounds(skeleton) {
	skeleton.setToSetupPose();
	skeleton.updateWorldTransform();
	var offset = new spine.Vector2();
	var size = new spine.Vector2();
	skeleton.getBounds(offset, size, []);
	return { offset: offset, size: size };
}
